----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:50:55 02/15/2007 
-- Design Name: 
-- Module Name:    DCOL - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use mylib.DCOL_pack.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity DCOL is
    generic (swap_byte : boolean := false; swap_lw : boolean := false; sim : boolean := false);
    Port ( vme_pads : inout vme_pad;
           clkin : in std_logic;
-- DCAL interface signals
           TRIG_clk_p : in std_logic;
           TRIG_clk_n : in std_logic;
           TRIG_din_p : in std_logic_vector(1 downto 0);
           TRIG_din_n : in std_logic_vector(1 downto 0);
           TRIG_dout_p : out std_logic;
           TRIG_dout_n : out std_logic;
           DCON_rx_in : in std_logic_vector(12 downto 1);
           DCON_tx_p : out std_logic_vector(12 downto 1);
           DCON_tx_n : out std_logic_vector(12 downto 1);
           DCON_test_p : out std_logic_vector(12 downto 1);
           DCON_test_n : out std_logic_vector(12 downto 1);
           DCON_pem : out std_logic_vector(1 downto 0);
-- SWITCHES
           SN : in std_logic_vector(7 downto 0);
           SW_BAR : in std_logic_vector(4 downto 0);
           SW_use : in std_logic;
--           SW_autoID : in std_logic;
--           SW_spare : in std_logic;
-- DCAL POWER CONTROL
           V50_ready : in std_logic;
           V50_ON : out std_logic;
-- ram pads
			  mem_pads : inout mem_pad;
-- interface signals to cpld and FLASH
			  INIT_b : out STD_LOGIC;
			  CPLD_ctrl : inout STD_LOGIC_VECTOR (4 downto 0);
			  M_Q : in STD_LOGIC
			  );
end DCOL;

architecture Behavioral of DCOL is
constant version : std_logic_vector(7 downto 0) := x"12";
signal clk_dcm : std_logic := '0';
signal clk : std_logic := '0';
signal locked0_n : std_logic := '0';
signal rst_mclk : std_logic := '0';
signal mclk0_dcm: std_logic := '0';
signal mclk90_dcm: std_logic := '0';
signal mclk180_dcm: std_logic := '0';
signal mclk270_dcm: std_logic := '0';
signal mclk0: std_logic := '0';
signal mclk90: std_logic := '0';
signal mclk180: std_logic := '0';
signal mclk270: std_logic := '0';
signal n_strobe : std_logic := '0';
signal strobe : std_logic := '0';
signal locked : std_logic_vector(1 downto 0) := (others => '0');
signal trig_clkin : std_logic := '0';
signal trig_clk : std_logic := '0';
signal trig_din : std_logic_vector(1 downto 0) := (others => '0');
signal trig_din_q : std_logic_vector(1 downto 0) := (others => '0');
signal trig_in : std_logic := '0';
signal trig_end : std_logic := '0';
signal trig_dout : std_logic := '0';
signal trig_data : std_logic := '0';
signal trig_time : std_logic := '0';
signal reset_time : std_logic := '0';
signal ec_trig_cntr : std_logic := '0';
signal ec_reset_cntr : std_logic := '0';
signal ec_tp_cntr : std_logic := '0';
signal tp_sync : std_logic_vector(2 downto 0) := (others => '0');
signal trig_cntr : std_logic_vector(31 downto 0) := (others => '0');
signal reset_cntr : std_logic_vector(31 downto 0) := (others => '0');
signal tp_cntr : std_logic_vector(31 downto 0) := (others => '0');
signal DCON_tx : std_logic_vector(12 downto 1) := (others => '0');
signal DCON_test : std_logic_vector(12 downto 1) := (others => '0');
signal start_bit : std_logic := '0';
signal ms_div : std_logic_vector(15 downto 0) := (others => '0');
signal second : std_logic := '0';
signal snd_div : std_logic_vector(23 downto 0) := (others => '0');
signal div7_q : std_logic := '0';
signal chk_lock : std_logic := '0';
signal rx_lock : std_logic_vector(12 downto 1) := (others => '0');
signal DCON_rx : std_logic_vector(12 downto 1) := (others => '0');
signal DCON_en : std_logic_vector(13 downto 1) := (others => '0');
signal reset : std_logic := '0';
signal reset_rx : std_logic := '0';
signal reset_rx_sync : std_logic_vector(1 downto 0) := (others => '0');
signal reset_mon : std_logic := '0';
signal csr : std_logic_vector(15 downto 0) := (others => '0');
signal run : std_logic := '0';
signal circular : std_logic := '0';
signal stand_alone : std_logic := '0';
signal skip_sorter : std_logic := '0';
signal flash_busy : std_logic := '0';
signal cmd : std_logic_vector(31 downto 0) := (others => '0');
signal evt_size : std_logic_vector(31 downto 0) := (others => '0');
signal evt_wp : std_logic_vector(22 downto 0) := (others => '0');
signal page_reg : std_logic_vector(10 downto 0) := (others => '0');
signal sel_buf : std_logic_vector(2 downto 0) := (others => '0');
signal reg_data : std_logic_vector(31 downto 0) := (others => '0');
signal buf_data : std_logic_vector(31 downto 0) := (others => '0');
signal mon_data : std_logic_vector(31 downto 0) := (others => '0');
signal flash_wdata : std_logic_vector(31 downto 0) := (others => '0');
signal flash_rdata : std_logic_vector(31 downto 0) := (others => '0');
signal mem_data : std_logic_vector(31 downto 0) := (others => '0');
-- sorter signals
signal hit_data : std_logic_vector(35 downto 0) := (others => '0');
signal hit_addr : std_logic_vector(5 downto 0) := (others => '0');
signal hit_rqst : std_logic_vector(3 downto 0) := (others => '0');
signal hit_gnt : std_logic_vector(3 downto 0) := (others => '0');
signal hit_end : std_logic_vector(3 downto 0) := (others => '0');
signal evt_space : std_logic_vector(10 downto 0) := (others => '0');
signal buf_afull : std_logic := '0';
signal buf_full : std_logic := '0';
-- DCON_if signals
signal ctrl_tx_data : std_logic_vector(31 downto 0) := (others => '0');
signal ctrl_rx_data : std_logic_vector(31 downto 0) := (others => '0');
signal ctrl_tx_csr : std_logic_vector(31 downto 0) := (others => '0');
signal ctrl_rx_csr : std_logic_vector(11 downto 0) := (others => '0');
signal DCON_data : std_logic_vector(8 downto 0) := (others => '0');
signal DCON_addr : std_logic_vector(5 downto 0) := (others => '0');
signal DCON_err : std_logic := '0';
signal DCON_we : std_logic_vector(2 downto 0) := (others => '0');
signal DCON_if_mon : std_logic_vector(6 downto 0) := (others => '0');
signal DCOLAD : std_logic_vector(3 downto 0) := (others => '0');

-- DDR signals
signal mem_status : std_logic_vector(15 downto 0) := (others => '0');
signal ddr_addr : std_logic_vector(22 downto 0) := (others => '0');
signal ddr_w_data : std_logic_vector(35 downto 0) := (others => '0');
signal ddr_length : std_logic_vector(3 downto 0) := (others => '0');
signal ddr_gnt : std_logic := '0';
signal ddr_read : std_logic := '0';
signal ddr_w_we : std_logic := '0';
signal ddr_rqst : std_logic := '0';
signal re_hit : std_logic := '0';
signal rst_mem : std_logic := '0';
signal mem_test : std_logic := '0';
signal evt_end : std_logic := '0';
signal evt_we : std_logic := '0';
signal evt_data : std_logic_vector(7 downto 0) := (others => '0');
signal sB_addr : std_logic_vector(3 downto 0) := (others => '0');
signal sB_rqst : std_logic := '0';
signal sB_gnt : std_logic := '0';
signal sB_g_dav : std_logic_vector(15 downto 0) := (others => '0');
signal we_sB : std_logic := '0';
signal sC_addr : std_logic_vector(3 downto 0) := (others => '0');
signal sC_rqst : std_logic := '0';
signal sC_gnt : std_logic := '0';
signal sC_ch_dav : std_logic_vector(11 downto 0) := (others => '0');
signal we_sC : std_logic := '0';
signal sorter_wa : std_logic_vector(5 downto 0) := (others => '0');
-- vme interface signals
signal vme_BLT : std_logic := '0';
signal ram_dav : std_logic := '0';
signal sel_mod : std_logic := '0';
signal sel_reg : std_logic := '0';
signal rfifo_afull : std_logic := '0';
signal vme_rd_ram : std_logic := '0';
signal sys_reset : std_logic := '0';
signal w_data : std_logic_vector(31 downto 0) := (others => '0');
signal r_data : std_logic_vector(31 downto 0) := (others => '0');
signal we_byte : std_logic_vector(3 downto 0) := (others => '0');
signal addr : std_logic_vector(22 downto 0) := (others => '0');
-- memory test
signal ec_lfsr : std_logic := '0';
signal mem_fail : std_logic := '0';
signal lfsr : std_logic_vector(31 downto 0) := (others => '0');
signal tst_addr : std_logic_vector(32 downto 0) := (others => '0');
signal saved_addr : std_logic_vector(31 downto 0) := (others => '0');
signal saved_lfsr : std_logic_vector(31 downto 0) := (others => '0');
signal saved_mem_data : std_logic_vector(31 downto 0) := (others => '0');
-- test TTM
--signal div3 : std_logic_vector(1 downto 0);
--signal div4 : std_logic_vector(1 downto 0);
--signal trig_seq : std_logic;
--signal secondp : std_logic_vector(3 downto 0);
--signal dcon_txp : std_logic_vector(12 downto 1);
begin
v50_ON <= DCON_en(13);
i_clk: bufg port map(i => clk_dcm, o => clk);
i_DCM_clk : DCM
	generic map(CLKIN_PERIOD => 16.7, CLK_FEEDBACK => "2X")
   port map (
      CLK2x => clk_dcm,     -- DCM CLK2x ouptput
      CLKFB => clk,   -- DCM clock feedback
      CLKIN => clkin,   -- Clock input (from IBUFG, BUFG or DCM)
      PSCLK => '0',   -- Dynamic phase adjust clock input
      PSEN => '0',     -- Dynamic phase adjust enable input
      PSINCDEC => '0', -- Dynamic phase adjust increment/decrement
      DSSEN => '0',   --
      RST => '0',      -- DCM asynchronous reset input
		LOCKED => locked(0)
   );
locked0_n <= not locked(0);
i_rst_mclk : SRL16
   generic map (
      INIT => X"ffff")
   port map (
      Q => rst_mclk,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '1',     -- Select[3] input
      CLK => clk,   -- Clock input
      D => locked0_n        -- SRL data input
   );
i_DCM_mclk: dcm 
	port map	
         ( CLKIN   => clk ,
           CLKFB   => mclk0 ,
           RST     => rst_mclk ,
           DSSEN   => '0' ,
           PSINCDEC=> '0' ,
           PSEN    => '0' ,
           PSCLK   => '0' ,
           CLK0    => mclk0_dcm ,
			  clk90  => mclk90_dcm,
			  clk180  => mclk180_dcm,
			  clk270  => mclk270_dcm,
           LOCKED  => locked(1));
mclk0bufg : BUFG port map (O=>mclk0, I=>mclk0_dcm);
mclk90bufg : BUFG port map (O=>mclk90, I=>mclk90_dcm);
mclk180 <= not mclk0;
mclk270bufg : BUFG port map (O=>mclk270, I=>mclk270_dcm);
process(trig_clk)
begin
  if(trig_clk'event and trig_clk = '0')then
    trig_din_q(0) <= trig_din(0);
  end if;
end process;
process(trig_clk)
begin
  if(trig_clk'event and trig_clk = '1')then
    trig_din_q(1) <= trig_din(1);
	 if(start_bit = '1')then
	   if(snd_div = x"98967f")then
	     snd_div <= (others => '0');
		  second <= '1';
		else
	     snd_div <= snd_div + 1;
		  second <= '0';
		end if;
	   div7_q <= snd_div(7);
	 end if;
	 trig_in <= trig_din_q(0);
--    if(stand_alone = '0')then
--		trig_in <= trig_din_q(0);
--	 else
--		trig_in <= trig_din_q(1);
--	 end if;
	 chk_lock <= snd_div(7) and not div7_q and start_bit;
	 trig_end <= snd_div(12) and snd_div(11);
    if(stand_alone = '0')then
	   trig_dout <= buf_afull;
	 elsif(second = '1')then
	   trig_dout <= '1';
	 elsif(trig_end = '1')then
	   trig_dout <= '0';
	 end if;
  end if;
end process;
i_trig_clkin: IBUFGDS
   generic map (IOSTANDARD => "lvds_25")
   port map (
      O => trig_clkin,
      I => trig_clk_p,
      IB => trig_clk_n
   );
i_trig_clk: bufgmux 
   port map(i0 => trig_clkin, i1 => clk_dcm, s => stand_alone, o => trig_clk);
g_trig_din: for i in 0 to 1 generate
  i_trig_din: IBUFDS
   generic map (IOSTANDARD => "lvds_25")
   port map (
      O => trig_din(i),
      I => trig_din_p(i),
      IB => trig_din_n(i)
   );
end generate;
i_trig_dout: OBUFDS
   generic map (IOSTANDARD => "lvds_25")
   port map (
      I => trig_dout,
      O => trig_dout_p,
      OB => trig_dout_n
   );
g_DCON_tx: for i in 1 to 12 generate
  i_DCON_tx: OBUFDS
   generic map (IOSTANDARD => "lvds_25")
   port map (
      I => DCON_tx(i),
      O => DCON_tx_p(i),
      OB => DCON_tx_n(i)
   );
end generate;
g_DCON_test: for i in 1 to 12 generate
  i_DCON_test: OBUFDS
   generic map (IOSTANDARD => "lvds_25")
   port map (
      I => DCON_test(i),
      O => DCON_test_p(i),
      OB => DCON_test_n(i)
   );
end generate;
DCON_pem <= "00";
g_rx_in: for i in 1 to 12 generate
  i_DCON_rx_in: DCON_rxin PORT MAP(
		clk => trig_clk,
		start_bit => start_bit,
		reset_rx => reset_rx_sync(1),
		chk_lock => chk_lock,
		DCON_en => DCON_en(i),
		DCON_rx => DCON_rx_in(i),
		rx_lock => rx_lock(i),
		q => DCON_rx(i)
	);
end generate;	
process(mclk0)
begin
  if(mclk0'event and mclk0 = '1')then
    n_strobe <= not n_strobe;
	 strobe <= n_strobe;
	 if(strobe = '1')then
	   if(sel_reg = '1' and addr(3 downto 0) = CMD_addr(5 downto 2) and we_byte(3) = '1')then
		  reset <= w_data(0);
		  reset_rx <= w_data(1) or w_data(0);
		  reset_mon <= w_data(2) or w_data(0);
		  mem_test <= w_data(7) and not csr(0);
		else
		  reset <= '0';
		  reset_rx <= '0';
		  reset_mon <= '0';
		  if((mem_fail = '1' and ram_dav = '0') or tst_addr(32) = '1' or csr(0) = '1')then
		    mem_test <= '0';
		  end if;
		end if;
		if(ms_div(15) = '1')then
		  ms_div <= (others => '0');
		else
		  ms_div <= ms_div + 1;
		end if;
	   if(sel_reg = '1' and addr(3 downto 0) = CSR_addr(5 downto 2))then
		  if(we_byte(3) = '1' and we_byte(1) = '0')then
		    csr(3 downto 0) <= csr(3 downto 0) or w_data(3 downto 0);
		  elsif(we_byte(1) = '1' and we_byte(3) = '0')then
		    csr(3 downto 0) <= csr(3 downto 0) and not w_data(19 downto 16);
		  elsif(we_byte(1) = '1' and we_byte(3) = '1')then
		    csr(3 downto 0) <= (csr(3 downto 0) or w_data(3 downto 0)) and not w_data(19 downto 16);
		  end if;
		end if;
	   if(sel_reg = '1' and addr(3 downto 0) = DCON_en_addr(5 downto 2))then
		  if(we_byte(2) = '1')then
		    DCON_en(13 downto 9) <= w_data(12 downto 8);
		  end if;
		  if(we_byte(3) = '1')then
		    DCON_en(8 downto 1) <= w_data(7 downto 0);
		  end if;
		end if;
		if(reset = '1')then
		  evt_wp <= "010" & x"00000";
		elsif(ddr_gnt = '1' and ddr_addr(22 downto 21) /= "00" and ddr_read = '0')then
		  evt_wp(20 downto 2) <= ddr_addr(20 downto 2) + 1;
		  evt_wp(1 downto 0) <= ddr_addr(1 downto 0);
		  if(ddr_addr(20 downto 2) = "1111111111111111111")then
		    evt_wp(22) <= ddr_addr(22) xor ddr_addr(21);
		    evt_wp(21) <= ddr_addr(22);
		  else
		    evt_wp(22 downto 21) <= ddr_addr(22 downto 21);
		  end if;
		end if;
		if(reset = '1')then
		  page_reg <= (others => '0');
		elsif(run = '1' and page_reg(10 downto 9) = "00")then
        page_reg(9) <= '1';		
		elsif(sel_reg = '1' and addr(3 downto 0) = PAGE_addr(5 downto 2))then
		  if(we_byte(3) = '1')then
		    if(run = '0')then
		      page_reg(7 downto 0) <= w_data(7 downto 0);
			 else
			   page_reg <= page_reg + 1;
			 end if;
		  end if;
		  if(run = '0' and we_byte(2) = '1')then
		    page_reg(10 downto 8) <= w_data(10 downto 8);
		  end if;
		end if;
		if(page_reg(10 downto 9) = "01" and evt_wp(22 downto 21) = "11")then
		  evt_space <= ("00" & page_reg(8 downto 0)) - evt_wp(22 downto 12);
		else
		  evt_space <= page_reg - evt_wp(22 downto 12);
		end if;
		if(evt_space = "00000000001")then
		  buf_full <= run;
		else
		  buf_full <= '0';
		end if;
		if(reset = '1' or evt_space(10 downto 6) = "00010")then
		  buf_afull <= '0';
		elsif(evt_space(10 downto 6) = "00001")then
		  buf_afull <= run;
		end if;
	 end if;
  end if;
end process;
run <= csr(0);
circular <= csr(1);
stand_alone <= csr(2);
skip_sorter <= csr(3);
csr(15 downto 4) <= x"000";
process(trig_clk)
begin
  if(trig_clk'event and trig_clk = '1')then
    reset_rx_sync <= reset_rx_sync(0) & reset_rx;
	 ec_trig_cntr <= trig_time and trig_data;
	 ec_reset_cntr <= reset_time and trig_data;
	 tp_sync <= tp_sync(2 downto 1) & trig_din(1);
	 ec_tp_cntr <= not tp_sync(2) and tp_sync(1) and not stand_alone;
  end if;
end process;
process(trig_clk,reset)
begin
  if(reset = '1')then
	 trig_cntr <= (others => '0');
	 reset_cntr <= (others => '0');
	 tp_cntr <= (others => '0');
  elsif(trig_clk'event and trig_clk = '1')then
	 if(ec_trig_cntr = '1')then
	   trig_cntr <= trig_cntr + 1;
	 end if;
	 if(ec_reset_cntr = '1')then
	   reset_cntr <= reset_cntr + 1;
	 end if;
	 if(ec_tp_cntr = '1')then
	   tp_cntr <= tp_cntr + 1;
	 end if;
  end if;
end process;
i_reset_time: delayN
  generic map(N=> 7) port map(d => start_bit, ce => '1', c => trig_clk, q => reset_time);
i_trig_time: delayN
  generic map(N=> 3) port map(d => reset_time, ce => '1', c => trig_clk, q => trig_time);
i_trig_ctrl: trig_ctrl PORT MAP(
		clk => trig_clk,
		trig_in => trig_in,
		stand_alone => stand_alone,
		second => second,
		DCON_en => DCON_en(12 downto 1),
		test_out => DCON_test,
		trig_out => trig_data,
		start_bit => start_bit
	);
DCOLAD <= not vme_pads.gan(3 downto 0);
i_DCON_if: DCON_if
   generic map(swap_byte => swap_byte)
	PORT MAP(
		clk => mclk0,
		reset => reset,
		n_strobe => n_strobe,
		start_bit => start_bit,
		trig_clk => trig_clk,
		trig_d0 => trig_data,
		sel_reg => sel_reg,
		addr => addr,
		w_data => w_data,
		we_byte => we_byte,
		ctrl_tx_data => ctrl_tx_data,
		ctrl_rx_data => ctrl_rx_data,
		DCOLAD => DCOLAD,
		DCON_en => DCON_en(12 downto 1),
		DCON_rx => DCON_rx,
		DCON_tx => DCON_tx,
		ctrl_tx_csr => ctrl_tx_csr,
		ctrl_rx_csr => ctrl_rx_csr,
		mon_cntr => dcon_if_mon,
		buf_full => buf_full,
		DCON_data => DCON_data,
		DCON_err => DCON_err,
		DCON_addr => DCON_addr,
		DCON_we => DCON_we
	);
g_sorter_a: for i in 0 to 2 generate
  i_sorterA_0: sorterA PORT MAP(
		clk => mclk0,
		n_strobe => n_strobe,
		reset => reset,
		skip => skip_sorter,
		one_ms => ms_div(15),
		DCON_data => DCON_data,
		DCON_we => DCON_we(i),
		DCON_addr => DCON_addr,
		hit_data => hit_data(i*9+8 downto i*9),
		hit_addr => hit_addr(i*2+1 downto i*2),
		hit_rqst => hit_rqst(i),
		hit_end => hit_end(i),
		hit_gnt => hit_gnt(i)
	);
end generate;
i_sorterB: sorterB PORT MAP(
		clk => mclk0,
		n_strobe => n_strobe,
		reset => reset,
		grp_dav => sB_g_dav,
		grp_data => mem_data,
		grp_addr => sorter_wa,
		grp_we => we_sB,
		grp_rqst => sB_rqst,
		grp_gnt => sB_gnt,
		grp_num => sB_addr,
		hit_data => hit_data(34 downto 27),
		hit_rqst => hit_rqst(3),
		hit_gnt => hit_gnt(3)
	);
i_sorterC: sorterC PORT MAP(
		clk => mclk0,
		n_strobe => n_strobe,
		reset => reset,
		circular => circular,
		buf_full => buf_full,
		one_ms => ms_div(15),
		ch_data => mem_data,
		ch_addr => sorter_wa,
		ch_dav => sC_ch_dav,
		ch_we => we_sC,
		ch_gnt => sC_gnt,
		ch_rqst => sC_rqst,
		ch_num => sC_addr,
		evt_data => evt_data,
		evt_end => evt_end,
		evt_we => evt_we
	);
i_vme_if: vme_if 
   generic map(swap_byte => swap_byte,swap_lw => swap_lw)
   PORT MAP(
		vme_pads => vme_pads,
		SW_BAR => SW_BAR,
		SW_use => SW_use,
		clk => mclk0,
		n_strobe => n_strobe,
		vme_BLT => vme_BLT,
		mem_test => mem_test,
		ram_dav => ram_dav,
		rd_ram => vme_rd_ram,
		rfifo_afull => rfifo_afull,
		sel_mod => sel_mod,
		sel_reg => sel_reg,
		r_data => r_data,
		w_data => w_data,
		we_byte => we_byte,
		sys_reset => sys_reset,
		addr => addr
	);
i_flash: flash 
   generic map(swap_byte => swap_byte)
   PORT MAP(
		clk => mclk0,
		locked => locked(1),
		reset => reset,
		n_strobe => n_strobe,
		sel_reg => sel_reg,
		addr => addr,
		we_byte => we_byte,
		w_data => w_data,
		flash_wdata => flash_wdata,
		flash_rdata => flash_rdata,
		flash_busy => flash_busy,
		reconf_b => CPLD_ctrl(2),
		CPLD_phase => CPLD_ctrl(4),
		MQ => M_Q,
		MD => CPLD_ctrl(0),
		MW_n => CPLD_ctrl(3),
		MCS => INIT_b
	);
-- sdram is endianess invariant
i_sdram: sdram
	generic map(sim => sim)
	PORT MAP(
		reset => reset,
		mclk0 => mclk0,
		mclk90 => mclk90,
		mclk180 => mclk180,
		mclk270 => mclk270,
		n_strobe => n_strobe,
		locked => locked(1),
		mem_test => mem_test,
		mem_status => mem_status,
		run => run,
		addr => addr,
		rfifo_data => mem_data,
		rd_ram => vme_rd_ram,
		ram_dav => ram_dav,
		re_hit => re_hit,
		ddr_gnt => ddr_gnt,
		ddr_w_we => ddr_w_we,
		ddr_read => ddr_read,
		ddr_rqst => ddr_rqst,
		ddr_length => ddr_length,
		ddr_addr => ddr_addr,
		ddr_w_data => ddr_w_data,
		mem_pads => mem_pads
	);
i_ddr_w_queue: ddr_w_queue
   generic map(swap_byte => swap_byte)
	PORT MAP(
		clk => mclk0,
		n_strobe => n_strobe,
		reset => rst_mem,
		run => run,
		circular => circular,
		skip => skip_sorter,
		mem_test => mem_test,
		DCON_en => DCON_en(12 downto 1),
		hit_data => hit_data,
		hit_addr => hit_addr,
		hit_rqst => hit_rqst,
		hit_end => hit_end,
		hit_gnt => hit_gnt,
		evt_end => evt_end,
		evt_we => evt_we,
		evt_data_in => evt_data,
		ddr_w_we => ddr_w_we,
		ddr_w_data => ddr_w_data,
		ddr_req => ddr_rqst,
		ddr_read => ddr_read,
		ddr_gnt => ddr_gnt,
		ddr_length => ddr_length,
		ddr_addr => ddr_addr,
		sB_addr => sB_addr,
		sB_rqst => sB_rqst,
		sB_gnt => sB_gnt,
		sB_g_dav => sB_g_dav,
		sC_addr => sC_addr,
		sC_rqst => sC_rqst,
		sC_gnt => sC_gnt,
		sC_ch_dav => sC_ch_dav,
		re_hit => re_hit,
		we_sB => we_sB,
		we_sC => we_sC,
		sorter_wa => sorter_wa,
		w_data => w_data,
		evt_wp => evt_wp,
		page_reg => page_reg,
		addr => addr,
		we_byte => we_byte,
		rfifo_afull => rfifo_afull,
		sel_mod => sel_mod,
		rd_ram => vme_rd_ram,
		ram_dav => ram_dav,
		vme_BLT => vme_BLT,
		evt_size => evt_size
	);
process(mclk0)
begin
  if(mclk0'event and mclk0 = '1')then
    if(strobe = '1')then
	   if(addr(22 downto 21) /= "00" or addr(12) = '1')then
		  sel_buf <= "110";
		elsif(addr(11) = '1')then
		  sel_buf <= "10" & addr(9);
		elsif(addr(10) = '1')then
		  sel_buf <= '0' & addr(9) & addr(7);
		else
		  sel_buf <= "111";
		end if;
		rst_mem <= reset or not mem_status(15);
	 end if;
  end if;
end process;
r_data <= reg_data when sel_reg = '1' else buf_data;
process(sel_buf,flash_wdata,flash_rdata,mon_data,ctrl_tx_data,ctrl_rx_data,mem_data)
begin
  case sel_buf is
    when "000" => buf_data <= flash_wdata;
    when "001" => buf_data <= flash_rdata;
    when "010" | "011" => buf_data <= mon_data;
    when "100" => buf_data <= ctrl_tx_data;
    when "101" => buf_data <= ctrl_rx_data;
    when "110" => buf_data <= mem_data;
    when others => buf_data <= (others => '0');
  end case;
end process;
cmd(5) <= not v50_ready;
cmd(6) <= mem_fail;
cmd(7) <= mem_test;
cmd(31) <= CPLD_ctrl(1);
process(addr,SN,csr,DCON_en)
begin
  case addr(3 downto 0) is
    when x"0" => reg_data <= cmd;
    when x"1" => reg_data <= version & SN & csr;
    when x"2" => reg_data <= x"0" & rx_lock & "000" & DCON_en;
    when x"3" => reg_data <= evt_size;
    when x"4" => reg_data <= x"0000" & mem_status;
    when x"5" => reg_data <= "0000000" & evt_wp & "00";
    when x"6" => reg_data <= reset_cntr;
    when x"7" => reg_data <= x"0000000" & "000" & flash_busy;
    when x"8" => reg_data <= x"00000" & '0' & page_reg;
    when x"9" => reg_data <= tp_cntr;
    when x"a" => reg_data <= ctrl_tx_csr;
    when x"b" => reg_data <= x"00000" & ctrl_rx_csr;
    when x"c" => reg_data <= trig_cntr;
    when x"d" => reg_data <= saved_addr;
    when x"e" => reg_data <= saved_lfsr;
    when x"f" => reg_data <= saved_mem_data;
    when others => reg_data <= (others => '0');
  end case;
end process;
i_counters: counters PORT MAP(
		clk => clk,
		reset => reset,
		n_strobe => n_strobe,
		addr => addr,
		trig_clk => trig_clk,
		hit_gnt => hit_gnt,
		dcon_if_cnt => dcon_if_mon,
		DCON_err => DCON_err,
		DCON_addr => DCON_addr,
		DCON_we => DCON_we,
		mon_data => mon_data
	);
-- random memory test
process(mclk0)
begin
  if(mclk0'event and mclk0 = '1')then
	 if(strobe = '1')then
      if(mem_test = '0')then
	     tst_addr <= (others => '0');
	   elsif(ec_lfsr = '1')then
	     tst_addr <= tst_addr + 1;
	   end if;
	   ec_lfsr <= mem_test and ram_dav;
	   if(reset = '1')then
	     mem_fail <= '0';
	   elsif(ec_lfsr = '1' and lfsr /= mem_data)then
		  mem_fail <= '1';
	   end if;
	   if(mem_test = '0')then
	     lfsr <= (others => '0');
	   elsif(ec_lfsr = '1')then
	     lfsr <= lfsr(30 downto 0) & not(lfsr(31) xor lfsr(21) xor lfsr(1) xor lfsr(0));
	   end if;
		if(mem_fail = '0' and ec_lfsr = '1')then
		  saved_addr <= tst_addr(31 downto 0);
		  saved_lfsr <= lfsr;
		  saved_mem_data <= mem_data;
		end if;
	 end if;	
  end if;
end process;
-- memory address
-- test TTM
--DCON_test(11 downto 1) <= "00000000000";
--i_secondp: delayN
--  generic map(N=> 11) port map(d => secondp(2), ce => '1', c => trig_clk, q => secondp(3));
--process(mclk0)
--begin
--  if(mclk0'event and mclk0 = '1')then
--    div3(1) <= div3(0);
--    div3(0) <= not div3(0) and not div3(1);
--	 secondp(1 downto 0) <= secondp(0) & second;
--	 if(secondp(3) = '1')then
--	   secondp(2) <= '0';
--	 elsif(secondp(1) = '1')then
--	   secondp(2) <= '1';
--	 end if;
--	 if(div3(1) = '1')then
--	   div4 <= div4 + 1;
--	 end if;
--	 case div4 is
--	   when "00" => trig_seq <= '1';
--	   when "10" => trig_seq <= secondp(2);
--	   when "11" => trig_seq <= secondp(2);
--	   when others => trig_seq <= '0';
--	 end case;
--	 DCON_test(12) <= trig_seq;
--  end if;
--end process;
--DCON_tx(11 downto 1) <= DCON_txp(11 downto 1);
--i_dcon_tx12:  fddrrse
--    port map(
--          d0 => '1',
--          d1 => '0',
--          c0 => mclk0,
--          c1 => mclk180,
--          ce => '1',
--          r  => '0',
--          s  => '0',
--          q  => dcon_tx(12));
end Behavioral;

