----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:58:17 03/06/2007 
-- Design Name: 
-- Module Name:    DCON_if - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use mylib.DCOL_pack.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity DCON_if is
    generic (swap_byte : boolean := false);
    Port ( 
-- system clock input	 
			  clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           n_strobe : in  STD_LOGIC;
           start_bit : in  STD_LOGIC; -- first '1' time slot of starting bit
-- DCOL VME address
           DCOLAD : in  STD_LOGIC_VECTOR (3 downto 0);
-- trigger clock
           trig_clk : in  STD_LOGIC;
           trig_d0 : in  STD_LOGIC;
           sel_reg : in  STD_LOGIC;
           addr : in  STD_LOGIC_VECTOR (22 downto 0);
           w_data : in  STD_LOGIC_VECTOR (31 downto 0);
           we_byte : in  STD_LOGIC_VECTOR (3 downto 0);
           ctrl_tx_data : out  STD_LOGIC_VECTOR (31 downto 0);
           ctrl_rx_data : out  STD_LOGIC_VECTOR (31 downto 0);
           DCON_en : in  STD_LOGIC_VECTOR (12 downto 1);
           DCON_rx : in  STD_LOGIC_VECTOR (12 downto 1);
           DCON_tx : out  STD_LOGIC_VECTOR (12 downto 1);
           ctrl_tx_csr : out  STD_LOGIC_VECTOR (31 downto 0);
           ctrl_rx_csr : out  STD_LOGIC_VECTOR (11 downto 0);
-- monitoe counters added 3-29-2008
           mon_cntr : out  STD_LOGIC_VECTOR (6 downto 0);
-- DCON data output to DDRRAM
           buf_full : in  STD_LOGIC;
           DCON_err : out  STD_LOGIC; -- checksum error for channel given by DCON_addr
           DCON_data : out  STD_LOGIC_VECTOR (8 downto 0);
           DCON_addr : out  STD_LOGIC_VECTOR (5 downto 0);
           DCON_we : out  STD_LOGIC_VECTOR (2 downto 0));
end DCON_if;

architecture Behavioral of DCON_if is
signal strobe : std_logic := '0';
signal div : std_logic_vector(3 downto 0) := (others => '0');
signal div_q : std_logic_vector(3 downto 0) := (others => '0');
signal DCON_tx_i : std_logic_vector(12 downto 1) := (others => '0');
signal ch_sel : std_logic_vector(11 downto 0) := (others => '0');
signal tx_data : std_logic_vector(11 downto 0) := (others => '0');
signal c_data : std_logic_vector(11 downto 0) := (others => '0');
signal rx_din : std_logic_vector(0 downto 0) := (others => '0');
signal c_valid : std_logic_vector(11 downto 0) := (others => '0');
signal c_wa : std_logic_vector(13 downto 0) := (others => '0');
signal c_wap : std_logic_vector(4 downto 0) := (others => '0');
signal c_cntr : std_logic_vector(4 downto 0) := (others => '0');
signal d_c_cntr : std_logic_vector(4 downto 0) := (others => '0');
signal c_cntr_wa : std_logic_vector(3 downto 0) := (others => '0');
signal d_data : std_logic_vector(11 downto 0) := (others => '0');
signal d_valid : std_logic_vector(11 downto 0) := (others => '0');
signal d_wa : std_logic_vector(13 downto 0) := (others => '0');
signal d_ra : std_logic_vector(10 downto 0) := (others => '0');
signal d_wap : std_logic_vector(7 downto 0) := (others => '0');
signal d_dout : std_logic_vector(7 downto 0) := (others => '0');
signal d_dout_dl : std_logic_vector(7 downto 0) := (others => '0');
signal sum : std_logic_vector(7 downto 0) := (others => '0');
signal new_sum : std_logic_vector(7 downto 0) := (others => '0');
signal d_cntr : std_logic_vector(7 downto 0) := (others => '0');
signal d_d_cntr : std_logic_vector(7 downto 0) := (others => '0');
signal d_cntr_wa : std_logic_vector(3 downto 0) := (others => '0');
signal we_dout_que : std_logic := '0';
signal dout_que : std_logic_vector(4 downto 0) := (others => '0');
signal dout_que_wa : std_logic_vector(3 downto 0) := (others => '0');
signal dout_que_wa_sync : std_logic_vector(3 downto 0) := (others => '0');
signal dout_que_ra : std_logic_vector(3 downto 0) := (others => '0');
signal tx_ra : std_logic_vector(13 downto 0) := (others => '0');
signal tx_rap : std_logic_vector(6 downto 0) := (others => '0');
signal DCON_addr_i : std_logic_vector(7 downto 0) := (others => '0');
signal DCON_data_i : std_logic_vector(8 downto 0) := (others => '0');
signal en_DCON_we : std_logic := '0';
signal DCON_we_i : std_logic := '0';
signal DCON_we_dl : std_logic := '0';
signal inc_DCON_addr : std_logic := '0';
signal check_sum : std_logic := '0';
signal check_sum_err : std_logic := '0';
signal error_byte : std_logic := '0';
signal error_byte_dl : std_logic := '0';
signal new_check_sum : std_logic := '0';
signal first_byte : std_logic := '0';
signal second_byte : std_logic := '0';
signal DCON_errp : std_logic := '0';
signal err : std_logic := '0';
signal DCAL_err : std_logic := '0';
signal rst_cycle : std_logic := '0';
signal rst_cycle_sync : std_logic := '0';
signal end_rst_cycle : std_logic := '0';
signal inc_d_ra : std_logic := '0';
signal tx_rb : std_logic_vector(31 downto 0) := (others => '0');
signal tx_dout : std_logic_vector(0 downto 0) := (others => '0');
signal tx_din : std_logic_vector(31 downto 0) := (others => '0');
signal tx_csr : std_logic_vector(31 downto 0) := (others => '0');
signal tx_cycle : std_logic_vector(1 downto 0) := (others => '0');
signal tx_done : std_logic_vector(11 downto 0) := (others => '0');
signal tx_toggle : std_logic := '0';
signal tx_toggle_sync : std_logic_vector(1 downto 0) := "00";
signal we_c : std_logic := '0';
signal we_d : std_logic := '0';
signal we_tx : std_logic := '0';
signal en_txn : std_logic := '1';
-- next data bit is valid slow control data
signal c_bit : std_logic_vector(11 downto 0) := (others => '0');
-- next data bit is valid event data
signal d_bit : std_logic_vector(11 downto 0) := (others => '0');
begin
ctrl_tx_data <= tx_rb;
ctrl_tx_csr <= tx_csr;
DCON_addr <= DCON_addr_i(5 downto 0);
process(trig_clk,rst_cycle)
begin
  if(rst_cycle = '1')then
	 c_valid <= (others => '0');
	 ctrl_rx_csr <= (others => '0');
	 we_c <= '0';
	 d_c_cntr <= (others => '0');
  elsif(trig_clk'event and trig_clk = '1')then
	 if(ch_sel(8) = '1')then
		c_valid <= c_bit;
	 end if;
	 if(we_byte(3) = '1' and sel_reg = '1' and addr(3 downto 0) = Tx_addr(5 downto 2))then
	   ctrl_rx_csr <= (others => '0');
	 elsif(we_c = '1' and c_wap = "11111")then
	   ctrl_rx_csr(conv_integer(c_wa(8 downto 5))) <= '1';
	 end if;
	 we_c <= c_valid(conv_integer(div_q));
	 if(we_c = '0')then
	   d_c_cntr <= (others => '0');
	 else
	   d_c_cntr <= c_wap + 1;
	 end if;
  end if;
end process;
process(trig_clk)
begin
  if(trig_clk'event and trig_clk = '1')then
    if(start_bit = '1' or div = x"b")then
	   div <= x"0";
	 else
	   div <= div + 1;
	 end if;
	 if(div = x"0")then
	   ch_sel(0) <= '1';
	 else
	   ch_sel(0) <= '0';
	 end if;
	 ch_sel(11 downto 1) <= ch_sel(10 downto 0);
	 if(ch_sel(2) = '1')then
		c_bit <= DCON_rx and DCON_en;
	 end if;
	 if(ch_sel(5) = '1')then
	   d_bit <= DCON_rx and DCON_en;
	 end if;
	 if(ch_sel(8) = '1')then
	   c_data <= DCON_rx;
	 end if;
	 rx_din(0) <= c_data(conv_integer(div_q));
    c_cntr_wa <= c_wa(8 downto 5);
    c_wa(8 downto 5) <= div_q;
    c_wap <= c_cntr;
		div_q <= div;
  end if;
end process;
c_wa(13 downto 9) <= Rx_buf(8 downto 4);
c_wa(4 downto 3) <= not c_wap(4 downto 3) when swap_byte = false else c_wap(4 downto 3);
c_wa(2 downto 0) <= not c_wap(2 downto 0);
g_c_cntr: for i in 0 to 4 generate
  i_c_cntr : RAM16X1D
   port map (
      DPO => c_cntr(i),     -- Read-only 1-bit data output for DPRA
      A0 => c_cntr_wa(0),       -- R/W address[0] input bit
      A1 => c_cntr_wa(1),       -- R/W address[1] input bit
      A2 => c_cntr_wa(2),       -- R/W address[2] input bit
      A3 => c_cntr_wa(3),       -- R/W ddress[3] input bit
      D => d_c_cntr(i),         -- Write 1-bit data input
      DPRA0 => div_q(0), -- Read-only address[0] input bit
      DPRA1 => div_q(1), -- Read-only address[1] input bit
      DPRA2 => div_q(2), -- Read-only address[2] input bit
      DPRA3 => div_q(3), -- Read-only address[3] input bit
      WCLK => trig_clk,   -- Write clock input
      WE => '1'        -- Write enable input
   );
end generate;
i_c_buf : RAMB16_S1_S36
   port map (
      DOB => ctrl_rx_data,      -- Port B 32-bit Data Output
      ADDRA => c_wa,  -- Port A 14-bit Address Input
      ADDRB => addr(8 downto 0),  -- Port B 9-bit Address Input
      CLKA => trig_clk,    -- Port A Clock
      CLKB => clk,    -- Port B Clock
      DIA => rx_din,      -- Port A 1-bit Data Input
      DIB => x"00000000",      -- Port B 32-bit Data Input
      DIPB => x"0",    -- Port-B 4-bit parity Input
      ENA => '1',      -- Port A RAM Enable Input
      ENB => strobe,      -- PortB RAM Enable Input
      SSRA => '0',    -- Port A Synchronous Set/Reset Input
      SSRB => '0',    -- Port B Synchronous Set/Reset Input
      WEA => we_c,      -- Port A Write Enable Input
      WEB => '0'       -- Port B Write Enable Input
   );
process(trig_clk,rst_cycle)
begin
  if(rst_cycle = '1')then
	 d_valid <= (others => '0');
	 we_d <= '0';
	 d_d_cntr <= (others => '0');
	 d_wap <= (others => '0');
  elsif(trig_clk'event and trig_clk = '1')then
	 if(ch_sel(8) = '1')then
		d_valid <= d_bit;
	 end if;
	 if(d_valid(conv_integer(div_q)) = '1')then
-- 3/12/08 this change tolerates dropped data enable bit
--	 if(d_valid(conv_integer(div_q)) = '1' or d_cntr(6 downto 0) /= "0000000")then
	   we_d <= '1';
	 else
	   we_d <= '0';
	 end if;
	 if(we_d = '0')then
	   d_d_cntr <= d_wap(7) & "0000000";
	 else
	   d_d_cntr <= d_wap + 1;
	 end if;
    d_wap <= d_cntr;
  end if;
end process;
process(trig_clk)
begin
  if(trig_clk'event and trig_clk = '1')then
    d_cntr_wa <= d_wa(11 downto 8);
    d_wa(11 downto 8) <= div_q;
  end if;
end process;
d_wa(13 downto 12) <= "00";
d_wa(7 downto 3) <= d_wap(7 downto 3);
d_wa(2 downto 0) <= not d_wap(2 downto 0);
g_d_cntr: for i in 0 to 7 generate
  i_d_cntr : RAM16X1D
   port map (
      DPO => d_cntr(i),     -- Read-only 1-bit data output for DPRA
      A0 => d_cntr_wa(0),       -- R/W address[0] input bit
      A1 => d_cntr_wa(1),       -- R/W address[1] input bit
      A2 => d_cntr_wa(2),       -- R/W address[2] input bit
      A3 => d_cntr_wa(3),       -- R/W ddress[3] input bit
      D => d_d_cntr(i),         -- Write 1-bit data input
      DPRA0 => div_q(0), -- Read-only address[0] input bit
      DPRA1 => div_q(1), -- Read-only address[1] input bit
      DPRA2 => div_q(2), -- Read-only address[2] input bit
      DPRA3 => div_q(3), -- Read-only address[3] input bit
      WCLK => trig_clk,   -- Write clock input
      WE => '1'        -- Write enable input
   );
end generate;
g_dout_que: for i in 0 to 4 generate
  i_dout_que : RAM16X1D
   port map (
      DPO => dout_que(i),     -- Read-only 1-bit data output for DPRA
      A0 => dout_que_wa(0),       -- R/W address[0] input bit
      A1 => dout_que_wa(1),       -- R/W address[1] input bit
      A2 => dout_que_wa(2),       -- R/W address[2] input bit
      A3 => dout_que_wa(3),       -- R/W ddress[3] input bit
      D => d_wa(i+7),         -- Write 1-bit data input
      DPRA0 => dout_que_ra(0), -- Read-only address[0] input bit
      DPRA1 => dout_que_ra(1), -- Read-only address[1] input bit
      DPRA2 => dout_que_ra(2), -- Read-only address[2] input bit
      DPRA3 => dout_que_ra(3), -- Read-only address[3] input bit
      WCLK => trig_clk,   -- Write clock input
      WE => we_dout_que        -- Write enable input
   );
end generate;
we_dout_que <= '1' when we_d = '1' and d_wap(6 downto 0) = "1111111" else '0';
process(trig_clk)
begin
  if(trig_clk'event and trig_clk = '1')then
		if(rst_cycle_sync = '1')then
			dout_que_wa <= x"0";
		elsif(we_dout_que = '1')then
			if(dout_que_wa(1 downto 0) = "00")then
				dout_que_wa(3) <= dout_que_wa(2);
			end if;
			if(dout_que_wa(1 downto 0) = "10")then
				dout_que_wa(2) <= not dout_que_wa(3);
			end if;
			if(dout_que_wa(0) = '1')then
				dout_que_wa(1) <= dout_que_wa(3) xnor dout_que_wa(2);
			end if;
			dout_que_wa(0) <= dout_que_wa(3) xor dout_que_wa(2) xor not dout_que_wa(1);
		end if;
  end if;
end process;
process(clk)
begin
  if(clk'event and clk = '1')then
		if(strobe = '1')then
			if(rst_cycle = '1')then
				dout_que_wa_sync <= x"0";
			else
				dout_que_wa_sync <= dout_que_wa;
			end if;
			if(rst_cycle = '1')then
				dout_que_ra <= x"0";
			elsif(inc_d_ra = '0' and dout_que_wa_sync /= dout_que_ra)then
				if(dout_que_ra(1 downto 0) = "00")then
					dout_que_ra(3) <= dout_que_ra(2);
				end if;
				if(dout_que_ra(1 downto 0) = "10")then
					dout_que_ra(2) <= not dout_que_ra(3);
				end if;
				if(dout_que_ra(0) = '1')then
					dout_que_ra(1) <= dout_que_ra(3) xnor dout_que_ra(2);
				end if;
				dout_que_ra(0) <= dout_que_ra(3) xor dout_que_ra(2) xor not dout_que_ra(1);		  
			end if;
	 end if;
  end if;
end process;
process(clk)
begin
  if(clk'event and clk = '1')then
    strobe <= n_strobe;
		if(strobe = '1')then
			if(check_sum = '1')then
        DCON_addr_i(7 downto 4) <= d_ra(8 downto 5);
			end if;
			if(inc_d_ra = '0')then
				en_DCON_we <= not buf_full;
			end if;
			if(rst_cycle = '1')then
				DCON_we_i <= '0';
				DCON_we <= "000";
			else
				DCON_we_i <= inc_d_ra and en_DCON_we;
				DCON_we(0) <= DCON_we_dl and not DCON_addr_i(7) and not DCON_addr_i(6);
				DCON_we(1) <= DCON_we_dl and DCON_addr_i(6);
				DCON_we(2) <= DCON_we_dl and DCON_addr_i(7);
			end if;
			if(inc_d_ra = '1' and en_DCON_we = '0' and d_ra(3 downto 0) = x"f")then
				mon_cntr(6) <= '1';
			else
				mon_cntr(6) <= '0';
			end if;
			if(rst_cycle = '1')then
				inc_d_ra <= '0';
			elsif(inc_d_ra = '0' and dout_que_wa_sync /= dout_que_ra)then
				inc_d_ra <= '1';
			elsif(d_ra(3 downto 0) = x"f")then
				inc_d_ra <= '0';
			end if;
			if(inc_d_ra = '0')then
				d_ra(8 downto 4) <= dout_que;
			end if;
			if(rst_cycle = '1')then
				d_ra(3 downto 0) <= x"0";
			elsif(inc_d_ra = '1')then
				d_ra(3 downto 0) <= d_ra(3 downto 0) + 1;
			end if;
		end if;	
  end if;
end process;
i_d_buf : RAMB16_S1_S9
   port map (
      DOB => d_dout,      -- Port B 8-bit Data Output
      ADDRA => d_wa,  -- Port A 14-bit Address Input
      ADDRB => d_ra,  -- Port B 11-bit Address Input
      CLKA => trig_clk,    -- Port A Clock
      CLKB => clk,    -- Port B Clock
      DIA => rx_din,      -- Port A 1-bit Data Input
      DIB => x"00",      -- Port B 8-bit Data Input
      DIPB => "0",    -- Port-B 1-bit parity Input
      ENA => '1',      -- Port A RAM Enable Input
      ENB => strobe,      -- PortB RAM Enable Input
      SSRA => '0',    -- Port A Synchronous Set/Reset Input
      SSRB => '0',    -- Port B Synchronous Set/Reset Input
      WEA => we_d,      -- Port A Write Enable Input
      WEB => '0'       -- Port B Write Enable Input
   );
process(clk)
begin
  if(clk'event and clk = '1')then
	 if(strobe = '1')then
	   if(rst_cycle = '1')then
	     tx_csr <= (others => '0');
      elsif(sel_reg = '1' and addr(3 downto 0) = Tx_addr(5 downto 2))then
		  if(we_byte(0) = '1')then
	       tx_csr(31 downto 24) <= w_data(31 downto 29) & "00000";
		  end if;
		  if(we_byte(1) = '1')then
	       tx_csr(23 downto 16) <= w_data(23 downto 16);
		  end if;
		  if(we_byte(2) = '1')then
	       tx_csr(15 downto 8) <= w_data(15 downto 8);
		  end if;
		  if(we_byte(3) = '1')then
	       tx_csr(7 downto 0) <= w_data(7 downto 0);
		  end if;
		  if(swap_byte = false)then
			 tx_toggle <= we_byte(3) xor tx_toggle;
		  else	 
			 tx_toggle <= we_byte(0) xor tx_toggle;
		  end if;
		else
		  for i in 0 to 11 loop
		    if(tx_done(i) = '1')then
			   tx_csr(i*2+1 downto i*2) <= "00";
			 end if;
		  end loop;
		end if;
	 end if;
  end if;
end process;
process(trig_clk,rst_cycle)
begin
  if(rst_cycle = '1')then
	 tx_cycle <= (others => '0');
  elsif(trig_clk'event and trig_clk = '1')then
	 if(tx_toggle_sync(0) /= tx_toggle_sync(1))then
		tx_cycle(0) <= '1';
	 elsif(ch_sel(0) = '1')then
		tx_cycle(0) <= '0';
	 end if;
	 if(ch_sel(0) = '1' and tx_cycle(0) = '1')then
	   tx_cycle(1) <= '1';
	 elsif(tx_csr(23 downto 0) = x"000000")then
	   tx_cycle(1) <= '0';
	 end if;
  end if;
end process;
process(trig_clk)
begin
  if(trig_clk'event and trig_clk = '1')then
    DCON_tx <= DCON_tx_i;
    for i in tx_data'range loop
	   DCON_tx_i(i+1) <= DCON_en(i+1) and (trig_d0 or (ch_sel(2) and tx_data(i)));
	 end loop;
	 if(ch_sel(2) = '1')then
	   for i in 0 to 11 loop
		  if((tx_csr(i*2+1) = '0' and tx_rap(6 downto 3) = x"2") or
-- new format does not send 8 bytes 09-21-2009
--		    (tx_csr(i*2) = '0' and tx_rap(6 downto 3) = x"3") or
--		    (tx_rap(6 downto 3) = x"a"))then
		    (tx_rap(6 downto 3) = x"3"))then
		    tx_done(i) <= '1';
		  else	 
		    tx_done(i) <= '0';
		  end if;
		end loop;
	 end if;
	 if(tx_cycle(1) = '0')then
	   tx_rap <= "0000000";
	 elsif(ch_sel(0) = '1')then
	   tx_rap <= tx_rap + 1;
	 end if;
	 for i in 0 to 11 loop
	   if(ch_sel(i) = '1')then
		  tx_data(i) <= tx_dout(0) and (tx_csr(2*i+1) or tx_csr(2*i));
		end if;
	 end loop;
	 tx_toggle_sync <= tx_toggle_sync(0) & tx_toggle;
  end if;
end process;
tx_ra(13 downto 10) <= div when tx_cycle(1) = '1' else x"2";
tx_ra(9 downto 5) <= tx_csr(31 downto 29) & tx_rap(6 downto 5);
tx_ra(4 downto 3) <= not tx_rap(4 downto 3) when swap_byte = false else tx_rap(4 downto 3);
tx_ra(2 downto 0) <= not tx_rap(2 downto 0);
tx_din(31 downto 24) <= w_data(31 downto 24) when we_byte(0) = '1' else tx_rb(31 downto 24);
tx_din(23 downto 16) <= w_data(23 downto 16) when we_byte(1) = '1' else tx_rb(23 downto 16);
tx_din(15 downto 8) <= w_data(15 downto 8) when we_byte(2) = '1' else tx_rb(15 downto 8);
tx_din(7 downto 0) <= w_data(7 downto 0) when we_byte(3) = '1' else tx_rb(7 downto 0);
i_tx_buf : RAMB16_S1_S36
   generic map(SIM_COLLISION_CHECK => "NONE")
   port map (
      DOA => tx_dout,      -- Port A 1-bit Data Output
      DOB => tx_rb,      -- Port B 32-bit Data Output
      ADDRA => tx_ra,  -- Port A 14-bit Address Input
      ADDRB => addr(8 downto 0),  -- Port B 9-bit Address Input
      CLKA => trig_clk,    -- Port A Clock
      CLKB => clk,    -- Port B Clock
      DIA => "0",      -- Port A 1-bit Data Input
      DIB => tx_din,      -- Port B 32-bit Data Input
      DIPB => x"0",    -- Port-B 4-bit parity Input
      ENA => '1',      -- Port A RAM Enable Input
      ENB => strobe,      -- PortB RAM Enable Input
      SSRA => en_txn,    -- Port A Synchronous Set/Reset Input
      SSRB => '0',    -- Port B Synchronous Set/Reset Input
      WEA => '0',      -- Port A Write Enable Input
      WEB => we_tx       -- Port B Write Enable Input
   );
en_txn <= not tx_cycle(1);
we_tx <= '1' when we_byte /= x"0" and addr(22 downto 9) = Tx_buf(24 downto 11) else '0';
process(clk)
begin
  if(clk'event and clk = '1')then
	 if(strobe = '1')then
	   if(reset = '1')then
		  rst_cycle <= '1';
		elsif(end_rst_cycle = '1')then
		  rst_cycle <= '0';
		end if;
		if(DCON_we_i = '0')then
		  sum <= (others => '0');
		else
		  sum <= sum + d_dout;
		end if;
		if(check_sum = '1')then
		  if(sum /= d_dout)then
		    err <= '1';
				check_sum_err <= '1';
		  else
		    err <= DCAL_err;
				check_sum_err <= '0';
		  end if;
		end if;
		DCON_errp <= first_byte and err;
		DCON_err <= DCON_errp;
		if(d_ra(3 downto 0) = x"e")then
		  error_byte <= '1';
		else
		  error_byte <= '0';
		end if;
		if(error_byte = '1' and d_dout(2 downto 0) /= "000")then
		  DCAL_err <= '1';
		else
		  DCAL_err <= '0';
		end if;
		check_sum <= error_byte;
		first_byte <= check_sum;
		if(second_byte = '1')then
			new_sum <= DCON_data_i(7 downto 0);
		else
			new_sum <= new_sum + DCON_data_i(7 downto 0);
		end if;
-- format change 09-21-2009
		second_byte <= first_byte;
--		if(first_byte = '1')then
--		  DCON_data <= err & d_dout_dl(7) & DCON_addr_i(7 downto 4) & d_dout_dl(2 downto 0);
		if(second_byte = '1')then
		  DCON_data_i <= err & DCOLAD & DCON_addr_i(7 downto 4);
-- format change 09-21-2009
		elsif(error_byte_dl = '1')then
		  DCON_data_i <= err & d_dout_dl(7 downto 4) & check_sum_err & d_dout_dl(2 downto 0);
		else
		  DCON_data_i <= err & d_dout_dl;
		end if;
		if(new_check_sum = '1')then
			DCON_data <= DCON_data_i(8) & new_sum;
		else
			DCON_data <= DCON_data_i;
		end if;
		if(rst_cycle = '1')then
		  inc_DCON_addr <= '0';
		else
		  inc_DCON_addr <= DCON_we_dl;
		end if;
		if(inc_DCON_addr = '0')then
		  DCON_addr_i(3 downto 0) <= x"0";
		else
		  DCON_addr_i(3 downto 0) <= DCON_addr_i(3 downto 0) + 1;
		end if;
	 end if;
  end if;
end process;
i_en_rst_cycle: delayN
  generic map(N=> 16) port map(d => reset, ce => strobe, c => clk, q => end_rst_cycle);
i_error_byte_dl: delayN
  generic map(N=> 16) port map(d => error_byte, ce => strobe, c => clk, q => error_byte_dl);
i_new_check_sum: delayN
  generic map(N=> 2) port map(d => error_byte_dl, ce => strobe, c => clk, q => new_check_sum);
g_d_dout_dl: for i in 0 to 7  generate
  i_d_dout_dl: delayN
    generic map(N=> 16) port map(d => d_dout(i), ce => strobe, c => clk, q => d_dout_dl(i));
end generate;
i_DCON_we: delayN
  generic map(N=> 17) port map(d => DCON_we_i, ce => strobe, c => clk, q => DCON_we_dl);
-- monitor counters added 3-29-2008
process(trig_clk)
begin
  if(trig_clk'event and trig_clk = '1')then
    rst_cycle_sync <= rst_cycle;
    if(rst_cycle_sync = '1')then
	   mon_cntr(5) <= '1';
	 elsif(we_d = '0' and d_wap(6 downto 0) /= "0000000")then
	   mon_cntr(5) <= '1';
	 else
	   mon_cntr(5) <= '0';
	 end if;
    if(rst_cycle_sync = '1')then
	   mon_cntr(4) <= '1';
	 elsif(we_d = '1' and d_wap(6 downto 0) = "1111111")then
	   mon_cntr(4) <= '1';
	 else
	   mon_cntr(4) <= '0';
	 end if;
  end if;
end process;
process(trig_clk)
begin
  if(trig_clk'event and trig_clk = '1')then
	 mon_cntr(3 downto 0) <= d_wa(11 downto 8);
  end if;
end process;
end Behavioral;

