----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:00:16 03/09/2007 
-- Design Name: 
-- Module Name:    DCON_rx_in - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
-- This module detects input edges and synchronize it with DCOL start bit
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity DCON_rxin is
    Port ( clk : in  STD_LOGIC;
           start_bit : in  STD_LOGIC;
           reset_rx : in  STD_LOGIC;
           chk_lock : in  STD_LOGIC;
           DCON_en : in  STD_LOGIC;
           DCON_rx : in  STD_LOGIC;
           rx_lock : out  STD_LOGIC;
           q : out  STD_LOGIC);
end DCON_rxin;

architecture Behavioral of DCON_rxin is
signal disable : std_logic := '0';
signal q_p : std_logic_vector(1 downto 0) := (others => '0');
signal q_n : std_logic_vector(1 downto 0) := (others => '0');
signal q_np : std_logic_vector(1 downto 0) := (others => '0');
signal q_pp : std_logic_vector(1 downto 0) := (others => '0');
signal div : std_logic_vector(1 downto 0) := (others => '0');
signal rising : std_logic_vector(2 downto 0) := (others => '0');
signal loc_a : std_logic_vector(2 downto 0) := (others => '1');
signal loc_b : std_logic_vector(2 downto 0) := "010";
signal loc_c : std_logic_vector(2 downto 0) := (others => '0');
signal cntr_a : std_logic_vector(3 downto 0) := (others => '0');
signal cntr_b : std_logic_vector(3 downto 0) := (others => '0');
signal dec_a : std_logic := '0';
signal dec_b : std_logic := '0';
signal q_i : std_logic_vector(7 downto 0) := (others => '0');
signal sel_q : std_logic_vector(1 downto 0) := (others => '0');
signal dl : std_logic_vector(1 downto 0) := (others => '0');
signal str : std_logic := '0';
signal lock : std_logic_vector(1 downto 0) := (others => '0');
signal fault_cntr : std_logic_vector(2 downto 0) := (others => '0');
signal lock_cntr : std_logic_vector(1 downto 0) := (others => '0');
attribute IOB : string;
attribute IOB of i_q_n0, i_q_n1, i_q_p0, i_q_p1 : label is "false";
--attribute hblknm : string;
--attribute hblknm of i_q_n0, i_q_n1 : label is "rx_FFn";
--attribute hblknm of i_q_p0, i_q_p1 : label is "rx_iFFp";
--attribute RLOC :string;
--attribute RLOC of i_q_n0,i_q_n1 :label is "X0Y0";
--attribute RLOC of i_q_p0,i_q_p1 :label is "X1Y0";
--attribute RLOC of q_np :signal is "X0Y1";
--attribute RLOC of q_pp :signal is "X1Y1";
begin
rx_lock <= lock(1);
disable <= not DCON_en;
i_q_n0: fdc_1 port map(d => DCON_rx, c => clk, clr => disable, q => q_n(0));
i_q_n1: fdc_1 port map(d => q_n(0), c => clk, clr => disable, q => q_n(1));
i_q_p0: fdc port map(d => DCON_rx, c => clk, clr => disable, q => q_p(0));
i_q_p1: fdc port map(d => q_p(0), c => clk, clr => disable, q => q_p(1));
process(clk)
begin
  if(clk'event and clk = '1')then
	 q_pp <= q_PP(0) & q_p(1);
	 q_np <= q_nP(0) & q_n(1);
-- edge detection
	 if(start_bit = '1' or div(1) = '1')then
	   div <= "00";
	 else
	   div <= div + 1;
	 end if;
	 if((q_pp(1) = '0' and q_np(1) = '1') or (q_pp(0) = '1' and q_np(1) = '0'))then
	   rising <= div & q_np(1);
	 else
	   rising <= "110";
	 end if;
	 if(rising(2 downto 1) /= "11")then
	   if(cntr_a = x"0" and loc_b /= rising)then
		  loc_a <= rising;
		end if;  
	   if(cntr_b = x"0" and loc_a /= rising)then
		  loc_b <= rising;
		end if;		
		if(loc_a = rising)then
		  if(cntr_a(3) = '0')then
		    cntr_a <= cntr_a + 1;
		  end if;
		  dec_a <= '0';
		  dec_b <= not dec_b;
		  if(cntr_b /= x"0" and dec_b = '1')then
		    cntr_b <= cntr_b - 1;
		  end if;
		elsif(loc_b = rising)then
		  dec_a <= not dec_a;
		  if(cntr_a /= x"0" and dec_a = '1')then
		    cntr_a <= cntr_a - 1;
		  end if;
		  dec_b <= '0';
		  if(cntr_b(3) = '0')then
		    cntr_b <= cntr_b + 1;
		  end if;
		else
		  dec_a <= not dec_a;
		  if(cntr_a /= x"0" and dec_a = '1')then
		    cntr_a <= cntr_a - 1;
		  end if;
		  dec_b <= not dec_b;
		  if(cntr_b /= x"0" and dec_b = '1')then
		    cntr_b <= cntr_b - 1;
		  end if;
		end if;
	 end if;
	 if(loc_c(2 downto 1) = div)then
		str <= '1';
	 else	
	   str <= '0';
	 end if;
	 if(reset_rx = '1')then
	   loc_c <= "010";
		sel_q <= "00";
	 elsif(str = '1')then
	   if(cntr_a(3) = '1')then
	     loc_c <= loc_a;
		  if(loc_c(2 downto 1) = "00" and loc_a(2) = '1')then
		    sel_q <= "10";
		  elsif(loc_a(2 downto 1) = "00" and loc_c(2) = '1')then
		    sel_q <= "01";
		  end if;
	   elsif(cntr_b(3) = '1')then
	     loc_c <= loc_b;
		  if(loc_c(2 downto 1) = "00" and loc_b(2) = '1')then
		    sel_q <= "10";
		  elsif(loc_b(2 downto 1) = "00" and loc_c(2) = '1')then
		    sel_q <= "01";
		  end if;
	   end if;
	 end if;
	 if(str = '1')then
	   if(loc_c(0) = '1')then
		  q_i(0) <= (q_pp(0) and q_pp(1)) or (q_pp(0) and q_np(1)) or (q_pp(1) and q_np(1));
		else
		  q_i(0) <= (q_np(0) and q_np(1)) or (q_np(0) and q_pp(0)) or (q_np(1) and q_pp(0));
		end if;
		q_i(2 downto 1) <= q_i(1 downto 0);
	 end if;
	 if(div(0) = '1')then
	   if(sel_q(1) = '1')then
	     q_i(3) <= q_i(2);
		elsif(sel_q(0) = '1')then
	     q_i(3) <= q_i(0);
		else
	     q_i(3) <= q_i(1);
		end if;
	   q_i(7 downto 5) <= q_i(6 downto 4);
	   if(lock(1) = '0')then
	     q <= '0';
	   else
	     q <= q_i(7);
	   end if;
	 end if;
	 if(reset_rx = '1' or lock_cntr(1) = '1' or fault_cntr(2) = '0')then
	   lock <= "00";
	 elsif(chk_lock = '1')then
	   lock <= lock(0) & '1';
	 end if;
	 if(chk_lock = '1' or lock_cntr(1) = '1')then
	   lock_cntr <= "00";
	 elsif(start_bit = '1' and q_i(4) = '0')then
	   locK_cntr <= lock_cntr + 1;
	 end if;
	 if(lock_cntr(1) = '1')then
	   dl <= dl + 1;
	 end if;
  end if;
end process;
process(clk,DCON_rx,DCON_en)
begin
  if(DCON_en = '0')then
    fault_cntr <= "000";
  elsif(DCON_rx = '0')then
    fault_cntr <= "111";
  elsif(clk'event and clk = '1')then
    if(start_bit = '1')then
	   fault_cntr <= fault_cntr(1 downto 0) & '0';
	 end if;
  end if;
end process;
i_dl : SRL16E
   port map (
      Q => q_i(4),       -- SRL data output
      A0 => dl(0),     -- Select[0] input
      A1 => dl(1),     -- Select[1] input
      A2 => '0',     -- Select[2] input
      A3 => '0',     -- Select[3] input
      CE => div(0),     -- Clock enable input
      CLK => clk,   -- Clock input
      D => q_i(3)        -- SRL data input
   );
end Behavioral;
