----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:19:15 03/23/2007 
-- Design Name: 
-- Module Name:    DelayN - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
-- delay d from 2 to 17 clocks with ce = '1'
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
library UNISIM;
use UNISIM.VComponents.all;

entity delayN is
    generic (N: positive := 2;
	          INIT : bit_vector := x"0000");
    port (
        c: in STD_LOGIC;
        d: in STD_LOGIC;
        ce: in STD_LOGIC;
        q: out STD_LOGIC
    );
end delayN;
architecture delayN_arch of delayN is
signal a: std_logic_vector(4 downto 0);
signal dl: std_logic;
signal q_i: std_logic := '0';
begin
q <= q_i;
a <= conv_std_logic_vector(N-2,5);
delay: srl16e
    generic map(INIT => INIT)
    port map(
           d => d,
           ce => ce,
           clk => c,
           a0 => a(0),
           a1 => a(1),
           a2 => a(2),
           a3 => a(3),
           q => dl);
process(c)
begin
  if(c'event and c = '1')then
    if(ce = '1')then
      q_i <= dl;
    end if;
  end if;
end process;
end delayN_arch;
