----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:43:19 03/28/2008 
-- Design Name: 
-- Module Name:    counters - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use mylib.DCOL_pack.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity counters is
    Port (
           clk : in std_logic;
           reset : in  STD_LOGIC;
           n_strobe : in  STD_LOGIC;
           addr : in  STD_LOGIC_VECTOR (22 downto 0);
           trig_clk : in std_logic;
           hit_gnt : in  STD_LOGIC_VECTOR (3 downto 0);
           dcon_if_cnt : in  STD_LOGIC_VECTOR (6 downto 0);
           DCON_err : in  STD_LOGIC; -- checksum error for channel given by DCON_addr
           DCON_addr : in  STD_LOGIC_VECTOR (5 downto 0);
           DCON_we : in  STD_LOGIC_VECTOR (2 downto 0);
			  mon_data :out  STD_LOGIC_VECTOR (31 downto 0)
			  );
end counters;

architecture Behavioral of counters is
-- monitor counters added 3-29-2008
signal hit_gnt_q : std_logic := '0';
signal strobe : std_logic := '0';
signal evt_cntr : std_logic_vector(7 downto 0) := (others => '0');
signal evt_cntrp : std_logic_vector(7 downto 0) := (others => '0');
signal d_evt_cntr : std_logic_vector(7 downto 0) := (others => '0');
signal evt_err_cntr : std_logic_vector(7 downto 0) := (others => '0');
signal evt_err_cntrp : std_logic_vector(7 downto 0) := (others => '0');
signal d_evt_err_cntr : std_logic_vector(7 downto 0) := (others => '0');
signal dcon_if_lb : std_logic_vector(7 downto 0) := (others => '0');
signal we_dcon_if_que : std_logic := '0';
signal d_dcon_if_que : std_logic_vector(4 downto 0) := (others => '0');
signal dcon_if_que : std_logic_vector(4 downto 0) := (others => '0');
signal dcon_if_wa : std_logic_vector(3 downto 0) := (others => '0');
signal dcon_if_wa_sync : std_logic_vector(3 downto 0) := (others => '0');
signal dcon_if_ra : std_logic_vector(3 downto 0) := (others => '0');
signal reset_cycle : std_logic := '0';
signal reset_cycle_dl : std_logic := '0';
signal ec_counter_wa : std_logic := '0';
signal we_counter : std_logic := '0';
signal counter_wa : std_logic_vector(8 downto 0) := (others => '0');
signal counter_in : std_logic_vector(31 downto 0) := (others => '0');
signal counter_outa : std_logic_vector(31 downto 0) := (others => '0');
signal counter_outb : std_logic_vector(31 downto 0) := (others => '0');
signal sel_DCON_if : std_logic := '0';
signal we_DCON_que : std_logic := '0';
signal rd_DCON_que : std_logic := '0';
signal DCON_que_dav : std_logic := '0';
signal DCON_que_din : std_logic_vector(4 downto 0) := (others => '0');
signal DCON_que_dout : std_logic_vector(4 downto 0) := (others => '0');
signal we_hit_que : std_logic := '0';
signal rd_hit_que : std_logic := '0';
signal hit_que_dav : std_logic := '0';
signal hit_que_din : std_logic_vector(1 downto 0) := (others => '0');
signal hit_que_dout : std_logic_vector(1 downto 0) := (others => '0');
begin
mon_data(31 downto 8) <= counter_outb(31 downto 8);
mon_data(7 downto 0) <= counter_outb(7 downto 0) when sel_dcon_if = '0' else
							dcon_if_lb;
process(clk)
begin
  if(clk'event and clk = '1')then
    strobe <= n_strobe;
  end if;
end process;

g_evt_cntr: for i in 0 to 7 generate
  i_evt_cntr : RAM16X1D
   port map (
      DPO => evt_cntrp(i),     -- Read-only 1-bit data output for DPRA
      SPO => evt_cntr(i),     -- R/W 1-bit data output
      A0 => dcon_if_cnt(0),       -- R/W address[0] input bit
      A1 => dcon_if_cnt(1),       -- R/W address[1] input bit
      A2 => dcon_if_cnt(2),       -- R/W address[2] input bit
      A3 => dcon_if_cnt(3),       -- R/W ddress[3] input bit
      D => d_evt_cntr(i),         -- Write 1-bit data input
      DPRA0 => addr(0), -- Read-only address[0] input bit
      DPRA1 => addr(1), -- Read-only address[1] input bit
      DPRA2 => addr(2), -- Read-only address[2] input bit
      DPRA3 => addr(3), -- Read-only address[3] input bit
      WCLK => trig_clk,   -- Write clock input
      WE => dcon_if_cnt(4)        -- Write enable input
   );
end generate;
d_evt_cntr <= x"00" when dcon_if_cnt(5 downto 4) = "11" else evt_cntr + 1;
g_evt_err_cntr: for i in 0 to 7 generate
  i_evt_err_cntr : RAM16X1D
   port map (
      DPO => evt_err_cntrp(i),     -- Read-only 1-bit data output for DPRA
      SPO => evt_err_cntr(i),     -- R/W 1-bit data output
      A0 => dcon_if_cnt(0),       -- R/W address[0] input bit
      A1 => dcon_if_cnt(1),       -- R/W address[1] input bit
      A2 => dcon_if_cnt(2),       -- R/W address[2] input bit
      A3 => dcon_if_cnt(3),       -- R/W ddress[3] input bit
      D => d_evt_err_cntr(i),         -- Write 1-bit data input
      DPRA0 => addr(0), -- Read-only address[0] input bit
      DPRA1 => addr(1), -- Read-only address[1] input bit
      DPRA2 => addr(2), -- Read-only address[2] input bit
      DPRA3 => addr(3), -- Read-only address[3] input bit
      WCLK => trig_clk,   -- Write clock input
      WE => dcon_if_cnt(5)        -- Write enable input
   );
end generate;
d_evt_err_cntr <= x"00" when dcon_if_cnt(5 downto 4) = "11" else evt_err_cntr + 1;
g_dcon_if_que: for i in 0 to 4 generate
  i_dcon_if_que : RAM16X1D
   port map (
      DPO => dcon_if_que(i),     -- Read-only 1-bit data output for DPRA
      A0 => dcon_if_wa(0),       -- R/W address[0] input bit
      A1 => dcon_if_wa(1),       -- R/W address[1] input bit
      A2 => dcon_if_wa(2),       -- R/W address[2] input bit
      A3 => dcon_if_wa(3),       -- R/W ddress[3] input bit
      D => d_dcon_if_que(i),         -- Write 1-bit data input
      DPRA0 => dcon_if_ra(0), -- Read-only address[0] input bit
      DPRA1 => dcon_if_ra(1), -- Read-only address[1] input bit
      DPRA2 => dcon_if_ra(2), -- Read-only address[2] input bit
      DPRA3 => dcon_if_ra(3), -- Read-only address[3] input bit
      WCLK => trig_clk,   -- Write clock input
      WE => we_dcon_if_que        -- Write enable input
   );
end generate;
process(trig_clk)
begin
  if(trig_clk'event and trig_clk = '1')then
	 d_dcon_if_que <= dcon_if_cnt(5) & dcon_if_cnt(3 downto 0);
	 if((dcon_if_cnt(4) = '1' and evt_cntr = x"ff") or (dcon_if_cnt(5) = '1' and evt_err_cntr = x"ff"))then
	   we_dcon_if_que <= '1';
	 else
	   we_dcon_if_que <= '0';
	 end if;
	 if(dcon_if_cnt(5 downto 4) = "11")then
	   dcon_if_wa <= x"0";
	 elsif(we_dcon_if_que = '1')then
		if(dcon_if_wa(1 downto 0) = "00")then
	     dcon_if_wa(3) <= dcon_if_wa(2);
		end if;
		if(dcon_if_wa(1 downto 0) = "10")then
	     dcon_if_wa(2) <= not dcon_if_wa(3);
		end if;
		if(dcon_if_wa(0) = '1')then
	     dcon_if_wa(1) <= dcon_if_wa(3) xnor dcon_if_wa(2);
		end if;
	   dcon_if_wa(0) <= dcon_if_wa(3) xor dcon_if_wa(2) xor not dcon_if_wa(1);
	 end if;
  end if;
end process;
process(clk)
begin
  if(clk'event and clk = '1')then
    if(strobe = '1')then
	   if(reset = '1')then
		  reset_cycle <= '1';
		elsif(counter_wa(5 downto 0) = "111111")then
		  reset_cycle <= '0';
		end if;
		if(reset = '1')then
		  counter_wa <= (others => '0');
		elsif(reset_cycle = '1')then
		  counter_wa(5 downto 0) <= counter_wa(5 downto 0) + 1;
		elsif(ec_counter_wa = '1')then
		  if(dcon_if_wa_sync /= dcon_if_ra)then
		    counter_wa(5 downto 0) <= '0' & dcon_if_que;
		  elsif(DCON_que_dav = '1')then
		    counter_wa(5 downto 0) <= '1' & dcon_que_dout;
		  else
		    counter_wa(5 downto 0) <= x"f" & hit_que_dout;
		  end if;	 
		end if;
	   if(reset_cycle = '1')then
	     dcon_if_wa_sync <= x"0";
		else
	     dcon_if_wa_sync <= dcon_if_wa;
		end if;
		if(hit_gnt = x"0")then
		  hit_gnt_q <= '0';
		else
		  hit_gnt_q <= '1';
		end if;
		if(ec_counter_wa = '1' and (dcon_if_wa_sync /= dcon_if_ra or DCON_que_dav = '1' or hit_que_dav = '1'))then
		  ec_counter_wa <= '0';
		else
		  ec_counter_wa <= '1';
		end if;
		if(reset_cycle = '1')then
		  we_counter <= '1';
		elsif(ec_counter_wa = '0')then
		  we_counter <= '1';
		else
		  we_counter <= '0';
		end if;
		reset_cycle_dl <= reset_cycle;
		if(addr(8 downto 5) = x"0")then
		  sel_dcon_if <= '1';
		else
		  sel_dcon_if <= '0';
		end if;
		if(addr(4) = '1')then
		  dcon_if_lb <= evt_err_cntrp;
		else  
		  dcon_if_lb <= evt_cntrp;
		end if;
		if(reset_cycle = '1')then
		  dcon_if_ra <= x"0";
		elsif(ec_counter_wa = '1' and dcon_if_wa_sync /= dcon_if_ra)then
		  if(dcon_if_ra(1 downto 0) = "00")then
	       dcon_if_ra(3) <= dcon_if_ra(2);
		  end if;
		  if(dcon_if_ra(1 downto 0) = "10")then
	       dcon_if_ra(2) <= not dcon_if_ra(3);
		  end if;
		  if(dcon_if_ra(0) = '1')then
	       dcon_if_ra(1) <= dcon_if_ra(3) xnor dcon_if_ra(2);
		  end if;
	     dcon_if_ra(0) <= dcon_if_ra(3) xor dcon_if_ra(2) xor not dcon_if_ra(1);		  
		end if;
	 end if;
  end if;
end process;
i_counter : RAMB16_S36_S36
   generic map (
      SIM_COLLISION_CHECK => "NONE") -- "NONE", "WARNING", "GENERATE_X_ONLY", "ALL" 
  port map (
      DOA => counter_outa,      -- Port A 32-bit Data Output
      DOB => counter_outb,      -- Port B 32-bit Data Output
      ADDRA => counter_wa,  -- Port A 9-bit Address Input
      ADDRB => addr(8 downto 0),  -- Port B 9-bit Address Input
      CLKA => clk,    -- Port A 1-bit Clock
      CLKB => clk,    -- Port B 1-bit Clock
      DIA => counter_in,      -- Port A 32-bit Data Input
      DIB => x"00000000",      -- Port B 32-bit Data Input
      DIPA => x"0",    -- Port A 4-bit parity Input
      DIPB => x"0",    -- Port-B 4-bit parity Input
      ENA => strobe,      -- Port A 1-bit RAM Enable Input
      ENB => strobe,      -- Port B 1-bit RAM Enable Input
      SSRA => '0',    -- Port A 1-bit Synchronous Set/Reset Input
      SSRB => '0',    -- Port B 1-bit Synchronous Set/Reset Input
      WEA => we_counter,      -- Port A 4-bit Write Enable Input
      WEB => '0'       -- Port B 4-bit Write Enable Input
   );
counter_in <= (others => '0') when reset_cycle_dl = '1' else counter_outa + 256 when counter_wa(5) = '0' else
					counter_outa + 1;
i_DCON_que: srl_fifo
	generic map(N => 5)
	PORT MAP(
		rst => reset_cycle,
		din => DCON_que_din,
		we => we_DCON_que,
		clk => clk,
		re => rd_DCON_que,
		dav => DCON_que_dav,
		dout => DCON_que_dout
	);
we_DCON_que <= strobe when DCON_addr(3 downto 0) = x"8" or DCON_err = '1' or dcon_if_cnt(6) = '1' else '0';
rd_DCON_que <= strobe when counter_wa(5) = '1' and counter_wa(4 downto 2) /= "111" and ec_counter_wa = '0' else '0';
DCON_que_din(4) <= DCON_err or dcon_if_cnt(6);
DCON_que_din(3) <= DCON_we(2) or dcon_if_cnt(6);
DCON_que_din(2) <= DCON_we(1) or dcon_if_cnt(6);
DCON_que_din(1) <= DCON_addr(5);
DCON_que_din(0) <= DCON_addr(4);
i_hit_que: srl_fifo
	generic map(N => 2)
	PORT MAP(
		rst => reset_cycle,
		din => hit_que_din,
		we => we_hit_que,
		clk => clk,
		re => rd_hit_que,
		dav => hit_que_dav,
		dout => hit_que_dout
	);
we_hit_que <= strobe when hit_gnt /= x"0" and hit_gnt_q = '0' else '0';
rd_hit_que <= strobe when counter_wa(5 downto 2) = "1111" and ec_counter_wa = '0' else '0';
hit_que_din(1) <= hit_gnt(3) or hit_gnt(2);
hit_que_din(0) <= hit_gnt(3) or hit_gnt(1);
end Behavioral;

