----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    09:47:58 04/22/2007 
-- Design Name: 
-- Module Name:    ddrram - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use mylib.DCOL_pack.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity ddrram is
    Port ( 
           mem_pads : inout  mem_pad);
end ddrram;

architecture Behavioral of ddrram is
--signal clk : std_logic := '0';
--signal oe_mdq : std_logic := '0';
--signal w_cycle : std_logic := '0';
--signal r_cycle : std_logic := '0';
--signal w_burst : std_logic := '0';
--signal r_burst : std_logic := '0';
--signal mdq : std_logic_vector(15 downto 0) := (others => '0');
--signal dqs : std_logic_vector(1 downto 0) := (others => '0');
--signal buf_p : std_logic_vector(15 downto 0) := (others => '0');
--signal buf_n : std_logic_vector(15 downto 0) := (others => '0');
--signal we : std_logic_vector(1 downto 0) := (others => '0');
--signal burst_cntr : std_logic_vector(1 downto 0) := (others => '0');
--signal cmd : std_logic_vector(2 downto 0) := (others => '0');
--signal addr : std_logic_vector(22 downto 0) := (others => '0');
--signal addr_n : std_logic_vector(10 downto 0) := (others => '0');
	SIGNAL mdq :  std_logic_vector(15 downto 0);
	SIGNAL dq_o :  std_logic_vector(15 downto 0);
	SIGNAL T_dq :  std_logic;
	SIGNAL dqs :  std_logic_vector(1 downto 0);
	SIGNAL dqs_o :  std_logic_vector(1 downto 0);
	SIGNAL T_dqs :  std_logic;
component ddr
  port(
      Clk: in std_logic;
      Clk_n: in std_logic;
      Cke: in std_logic;
      Cs_n: in std_logic;
      Ras_n: in std_logic;
      Cas_n: in std_logic;
      We_n: in std_logic;
      Ba: in std_logic_vector(1 downto 0);
      Addr: in std_logic_vector(12 downto 0);
      Dm: in std_logic_vector(1 downto 0);
      Dq: in std_logic_vector(15 downto 0);
      Dq_o: out std_logic_vector(15 downto 0);
      T_dq: out std_logic;
      Dqs: in std_logic_vector(1 downto 0);
      Dqs_o: out std_logic_vector(1 downto 0);
      T_dqs: out std_logic
  );
end component;
begin
	mem_pads.mdq <= "LLLLLLLLLLLLLLLL" when T_dq = '1' else dq_o;
	mem_pads.dqs <= "HH" when T_dqs = '1' else dqs_o after 2ns;
i_ddr: ddr port map(
      Clk => mem_pads.mclk,
      Clk_n => mem_pads.mclk_n,
      Cke =>mem_pads. mclke,
		Dq =>mem_pads.mdq,
		Dq_o => dq_o,
		T_dq => T_dq,
		Addr => mem_pads.ma,
		Ba => mem_pads.mba,
		Dm => mem_pads.dm,
		Dqs => mem_pads.dqs,
		Dqs_o => dqs_o,
		T_dqs => T_dqs,
		We_n => mem_pads.we_n,
		Ras_n => mem_pads.ras_n,
		Cas_n => mem_pads.cas_n,
		Cs_n => mem_pads.cs_n
			);
--clk <= mem_pads.mclk;
--cmd <= mem_pads.ras_n & mem_pads.cas_n & mem_pads.we_n;
--mem_pads.mdq <= mdq after 2.8ns;
--mem_pads.dqs <= dqs after 2.8ns;
--mdq <=(others => 'Z') when oe_mdq = '0' else buf_p when clk = '1' else buf_n;
--dqs <= "ZZ" when oe_mdq = '0' and r_burst = '0' else "00" when oe_mdq = '0' else clk & clk;
--process(clk)
--begin
--  if(clk'event and clk = '1')then
--    if(cmd = "011")then
--	   addr(22 downto 8) <= mem_pads.mba & mem_pads.ma;
--	 end if;
--	 if(cmd = "101")then
--	   r_cycle <= '1';
--	 elsif(burst_cntr = "11")then
--	   r_cycle <= '0';
--	 end if;
--	 r_burst <= r_cycle;
--	 oe_mdq <= r_burst;
--	 if(w_cycle = '0' and r_cycle = '0')then
--	   burst_cntr <= "00";
--	 else
--	   burst_cntr <= burst_cntr + 1;
--	 end if;
--	 if(cmd = "100")then
--	   w_cycle <= '1';
--	 elsif(burst_cntr = "11")then
--	   w_cycle <= '0';
--	 end if;
--    if(cmd = "100" or cmd = "101")then
--	   addr(7 downto 0) <= mem_pads.ma(8 downto 1);
--	 end if;
--    if(w_burst = '1' or r_burst = '1')then
--	   addr(7 downto 0) <= addr(7 downto 0) + 1;
--	 end if;
--  end if;
--end process;
--process(clk)
--begin
--  if(clk'event and clk = '0')then
--    addr_n <= addr(10 downto 0);
--	 w_burst <= w_cycle;
--  end if;
--end process;
--i_buf_0 : RAMB16_S9_S9
--   generic map(SIM_COLLISION_CHECK => "NONE")
--   port map (
--         dia => x"00", 
--         dipa => "0", 
--         addra => addr(10 downto 0),
--         clka => mem_pads.mclk, 
--         ssra => '0', 
--         ena => '1', 
--         wea => '0', 
--         doa => buf_p(7 downto 0), 
--         dib =>  mem_pads.mdq(7 downto 0),
--         dipb => "0",
--         addrb => addr(10 downto 0),
--         clkb => mem_pads.mclk,
--         ssrb => '0',
--         enb => '1',
--         web => we(0));
--i_buf_1 : RAMB16_S9_S9
--   generic map(SIM_COLLISION_CHECK => "NONE")
--   port map (
--         dia => x"00", 
--         dipa => "0", 
--         addra => addr(10 downto 0),
--         clka => mem_pads.mclk, 
--         ssra => '0', 
--         ena => '1', 
--         wea => '0', 
--         doa => buf_p(15 downto 8), 
--         dib =>  mem_pads.mdq(15 downto 8),
--         dipb => "0",
--         addrb => addr(10 downto 0),
--         clkb => mem_pads.mclk,
--         ssrb => '0',
--         enb => '1',
--         web => we(1));
--i_buf_2 : RAMB16_S9_S9
--   generic map(SIM_COLLISION_CHECK => "NONE")
--   port map (
--         dia => x"00", 
--         dipa => "0", 
--         addra => addr_n,
--         clka => mem_pads.mclk_n, 
--         ssra => '0', 
--         ena => '1', 
--         wea => '0', 
--         doa => buf_n(7 downto 0), 
--         dib =>  mem_pads.mdq(7 downto 0),
--         dipb => "0",
--         addrb => addr_n,
--         clkb => mem_pads.mclk_n,
--         ssrb => '0',
--         enb => '1',
--         web => we(0));
--i_buf_3 : RAMB16_S9_S9
--   generic map(SIM_COLLISION_CHECK => "NONE")
--   port map (
--         dia => x"00", 
--         dipa => "0", 
--         addra => addr_n,
--         clka => mem_pads.mclk_n, 
--         ssra => '0', 
--         ena => '1', 
--         wea => '0', 
--         doa => buf_n(15 downto 8), 
--         dib =>  mem_pads.mdq(15 downto 8),
--         dipb => "0",
--         addrb => addr_n,
--         clkb => mem_pads.mclk_n,
--         ssrb => '0',
--         enb => '1',
--         web => we(1));
--we(0) <= w_burst and not mem_pads.dm(0);
--we(1) <= w_burst and not mem_pads.dm(1);
end Behavioral;

